Package net.sf.saxon.pattern

## Class NodeKindTest

- java.lang.Object
- - net.sf.saxon.pattern.NodeTest
  - - net.sf.saxon.pattern.NodeKindTest

- All Implemented Interfaces:
    `java.util.function.Predicate<NodeInfo>`, `ItemType`, `ItemType.WithSequenceTypeCache`

      public class NodeKindTest
      extends NodeTest

  NodeTest is an interface that enables a test of whether a node has a particular name and kind. A NodeKindTest matches the node kind only.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.type.ItemType

      `ItemType.WithSequenceTypeCache`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static NodeKindTest` | `ATTRIBUTE` |
    `static NodeKindTest` | `COMMENT` |
    `static NodeKindTest` | `DOCUMENT` |
    `static NodeKindTest` | `ELEMENT` |
    `static NodeKindTest` | `NAMESPACE` |
    `static NodeKindTest` | `PROCESSING_INSTRUCTION` |
    `static NodeKindTest` | `TEXT` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `equals​(java.lang.Object other)` | Indicates whether some other object is "equal to" this one.
    `java.util.Optional<java.lang.String>` | `explainMismatch​(Item item, TypeHierarchy th)` | Get extra diagnostic information about why a supplied item does not conform to this item type, if available.
    `AtomicType` | `getAtomizedItemType()` | Get the content type allowed by this NodeTest (that is, the type annotation).
    `SchemaType` | `getContentType()` | Get the content type allowed by this NodeTest (that is, the type of content allowed).
    `double` | `getDefaultPriority()` | Determine the default priority of this node test when used on its own as a Pattern
    `java.util.function.IntPredicate` | `getMatcher​(NodeVectorTree tree)` | Get a matching function that can be used to test whether numbered nodes in a TinyTree or DominoTree satisfy the node test.
    `int` | `getNodeKind()` | Get the node kind matched by this test
    `int` | `getPrimitiveType()` | Determine the types of nodes to which this pattern applies.
    `UType` | `getUType()` | Get the corresponding `UType`.
    `int` | `hashCode()` | Returns a hash code value for the object.
    `static NodeTest` | `makeNodeKindTest​(int kind)` | Make a test for a given kind of node
    `boolean` | `matches​(int nodeKind, NodeName name, SchemaType annotation)` | Test whether this node test is satisfied by a given node.
    `boolean` | `matches​(Item item, TypeHierarchy th)` | Test whether a given item conforms to this type
    `static java.lang.String` | `nodeKindName​(int kind)` | Get the name of a node kind
    `boolean` | `test​(NodeInfo node)` | Test whether this node test is satisfied by a given node.
    `java.lang.String` | `toShortString()` |
    `java.lang.String` | `toString()` |
    `static java.lang.String` | `toString​(int kind)` |

    - ### Methods inherited from class net.sf.saxon.pattern.NodeTest

      `copy, getBasicAlphaCode, getFingerprint, getGenre, getMatchingNodeName, getPrimitiveItemType, getRequiredNodeNames, isAtomicType, isAtomizable, isNillable, isPlainType, one, oneOrMore, zeroOrMore, zeroOrOne`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.type.ItemType

      `getFullAlphaCode, getNormalizedDefaultPriority, isTrueItemType, toExportString`

    - ### Methods inherited from interface java.util.function.Predicate

      `and, negate, or`

- - ### Field Detail

    - #### DOCUMENT

          public static final NodeKindTest DOCUMENT

    - #### ELEMENT

          public static final NodeKindTest ELEMENT

    - #### ATTRIBUTE

          public static final NodeKindTest ATTRIBUTE

    - #### TEXT

          public static final NodeKindTest TEXT

    - #### COMMENT

          public static final NodeKindTest COMMENT

    - #### PROCESSING_INSTRUCTION

          public static final NodeKindTest PROCESSING_INSTRUCTION

    - #### NAMESPACE

          public static final NodeKindTest NAMESPACE

  - ### Method Detail

    - #### getNodeKind

          public int getNodeKind()

      Get the node kind matched by this test
      Returns:
        the matching node kind

    - #### getUType

          public UType getUType()

      Get the corresponding `UType`. A UType is a union of primitive item types.
      Returns:
        the smallest UType that subsumes this item type

    - #### makeNodeKindTest

          public static NodeTest makeNodeKindTest​(int kind)

      Make a test for a given kind of node

    - #### matches

          public boolean matches​(Item item,
                                 TypeHierarchy th)

      Description copied from interface: `ItemType`
      Test whether a given item conforms to this type
      Specified by:
        `matches` in interface `ItemType`
      Overrides:
        `matches` in class `NodeTest`
      Parameters:
        `item` - The item to be tested
        `th` - The type hierarchy cache. Currently used only when matching function items.
      Returns:
        true if the item is an instance of this type; false otherwise

    - #### matches

          public boolean matches​(int nodeKind,
                                 NodeName name,
                                 SchemaType annotation)

      Test whether this node test is satisfied by a given node. This method is only fully supported for a subset of NodeTests, because it doesn't provide all the information needed to evaluate all node tests. In particular (a) it can't be used to evaluate a node test of the form element(N,T) or schema-element(E) where it is necessary to know whether the node is nilled, and (b) it can't be used to evaluate a node test of the form document-node(element(X)). This in practice means that it is used (a) to evaluate the simple node tests found in the XPath 1.0 subset used in XML Schema, and (b) to evaluate node tests where the node kind is known to be an attribute.
      Specified by:
        `matches` in class `NodeTest`
      Parameters:
        `nodeKind` - The kind of node to be matched
        `name` - identifies the expanded name of the node to be matched. The value should be null for a node with no name.
        `annotation` - The actual content type of the node
      Returns:
        true if the node matches this node test

    - #### getMatcher

          public java.util.function.IntPredicate getMatcher​(NodeVectorTree tree)

      Description copied from class: `NodeTest`
      Get a matching function that can be used to test whether numbered nodes in a TinyTree or DominoTree satisfy the node test. (Calling this matcher must give the same result as calling `matchesNode(tree.getNode(nodeNr))`, but it may well be faster).
      Overrides:
        `getMatcher` in class `NodeTest`
      Parameters:
        `tree` - the tree against which the returned function will operate
      Returns:
        an IntPredicate; the matches() method of this predicate takes a node number as input, and returns true if and only if the node identified by this node number matches the node test.

    - #### test

          public boolean test​(NodeInfo node)

      Test whether this node test is satisfied by a given node. This alternative method is used in the case of nodes where calculating the fingerprint is expensive, for example DOM or JDOM nodes.
      Specified by:
        `test` in interface `java.util.function.Predicate<NodeInfo>`
      Overrides:
        `test` in class `NodeTest`
      Parameters:
        `node` - the node to be matched
      Returns:
        true if the node test is satisfied by the supplied node, false otherwise

    - #### getDefaultPriority

          public final double getDefaultPriority()

      Determine the default priority of this node test when used on its own as a Pattern
      Specified by:
        `getDefaultPriority` in interface `ItemType`
      Specified by:
        `getDefaultPriority` in class `NodeTest`
      Returns:
        the default priority for the pattern

    - #### getPrimitiveType

          public int getPrimitiveType()

      Determine the types of nodes to which this pattern applies. Used for optimisation.
      Specified by:
        `getPrimitiveType` in interface `ItemType`
      Overrides:
        `getPrimitiveType` in class `NodeTest`
      Returns:
        the type of node matched by this pattern. e.g. Type.ELEMENT or Type.TEXT

    - #### getContentType

          public SchemaType getContentType()

      Get the content type allowed by this NodeTest (that is, the type of content allowed). Return AnyType if there are no restrictions.
      Overrides:
        `getContentType` in class `NodeTest`
      Returns:
        the type annotation that all nodes matching this NodeTest must satisfy

    - #### getAtomizedItemType

          public AtomicType getAtomizedItemType()

      Get the content type allowed by this NodeTest (that is, the type annotation). Return AnyType if there are no restrictions. The default implementation returns AnyType.
      Specified by:
        `getAtomizedItemType` in interface `ItemType`
      Overrides:
        `getAtomizedItemType` in class `NodeTest`
      Returns:
        the best available item type of the atomic values that will be produced when an item of this type is atomized, or null if it is known that atomization will throw an error.

    - #### toString

          public java.lang.String toString()

      Specified by:
        `toString` in interface `ItemType`
      Overrides:
        `toString` in class `java.lang.Object`

    - #### toString

          public static java.lang.String toString​(int kind)

    - #### nodeKindName

          public static java.lang.String nodeKindName​(int kind)

      Get the name of a node kind
      Parameters:
        `kind` - the node kind, for example Type.ELEMENT or Type.ATTRIBUTE
      Returns:
        the name of the node kind, for example "element" or "attribute"

    - #### hashCode

          public int hashCode()

      Returns a hash code value for the object.
      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### equals

          public boolean equals​(java.lang.Object other)

      Indicates whether some other object is "equal to" this one.
      Overrides:
        `equals` in class `java.lang.Object`

    - #### explainMismatch

          public java.util.Optional<java.lang.String> explainMismatch​(Item item,
                                                                      TypeHierarchy th)

      Get extra diagnostic information about why a supplied item does not conform to this item type, if available. If extra information is returned, it should be in the form of a complete sentence, minus the closing full stop. No information should be returned for obvious cases.
      Specified by:
        `explainMismatch` in interface `ItemType`
      Overrides:
        `explainMismatch` in class `NodeTest`
      Parameters:
        `item` - the item that doesn't match this type
        `th` - the type hierarchy cache
      Returns:
        optionally, a message explaining why the item does not match the type

    - #### toShortString

          public java.lang.String toShortString()

      Overrides:
        `toShortString` in class `NodeTest`